/*
 * libtota
 *
 * Copyright (c) 2017 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *	 http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#pragma once

#include "SS_MultiProcessUpdate.h"
#include "SS_FSUpdate.h"
#include "SS_ImageUpdate.h"
#include "SS_Engine_Errors.h"
#include "SS_Engine_Update.h"

#include "ua_types.h"

#define MAX_PATH 256

#define NAND_BLOCK_BITS 18	  // 0x40000
#define NAND_PAGE_BITS 12	   // 0x1000

#if defined(PART_W) || defined(PART_WB1) || defined(PART_W3G) || defined(PART_TINY) \
	|| defined(PART_HIGGS) || defined(PART_KIRAN) || defined(PART_KIRANLTE) || defined(PART_ORBIS)
#define UA_RAM_SIZE		64*1024*1024	// it sould be same <RamSize>0x4000000</RamSize> in xml.
#else
#define UA_RAM_SIZE		512*1024*1024   // it sould be same <RamSize>0x20000000</RamSize> in xml.
#endif

#define FS_ID_MAX_LEN		4
#define DP_HEADER_SIZE		36
#define DP_START_OFFSET		0
#define  BACKUPBUFFER_NUM	4
#define SIZE_4GB (0Xffffffff)

/*******[ Multiprocess API sample implementation ]******/
#define _NOEXEC_
#define SAMPLE_PROCS_NUM	(0)
#define EXTRA_ARGS			(3)
#define HANDLE_RUN_PROC	"handle_run_process"

struct status_header_page {
	unsigned char preamble[5];  // state   , FOTA, SBLB, ZIMG, PLRM, MDEM, DONE, FAIL
	unsigned long format;	   // return , Ʒ  image  engine return DM error table  
	unsigned long reserved;	 // Not used
	unsigned long flexStatus;   // Not used
	unsigned long apfwStatus;   //zImage update  engine return 
	unsigned long apffsStatus;  //platform update enginereturn 
	unsigned long apuaStatus;   //sbl update enginereturn 
	unsigned long bpfwStatus;   //modem update enginereturn 
	unsigned long bpuaStatus;
};

void SS_unicode_to_char(const char *src, char *dest, int size);
